Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -2247,32 +3827,44 @@
 							break;
 							case 'im_path':
 								list($value,$version) = explode('|',$value);
-								if (!preg_match('/[[:space:]]/',$value,$reg) && strlen($value)<100)	{
+								if (!preg_match('/[[:space:]]/',$value,$reg) && strlen($value)<100) {
 									if (strcmp($GLOBALS['TYPO3_CONF_VARS']['GFX'][$key], $value)) {
 										$this->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'GFX\'][\'' . $key . '\']', $value);
 									}
-									if(doubleval($version)>0 && doubleval($version)<4)	{	// Assume GraphicsMagick
+									if(doubleval($version)>0 && doubleval($version)<4) {	// Assume GraphicsMagick
 										$value_ext = 'gm';
-									} elseif(doubleval($version)<5)	{	// Assume ImageMagick 4.x
+									} elseif(doubleval($version)<5) {	// Assume ImageMagick 4.x
 										$value_ext = '';
 									} elseif(doubleval($version) >= 6) {	// Assume ImageMagick 6.x
 										$value_ext = 'im6';
 									} else	{	// Assume ImageMagick 5.x
 										$value_ext = 'im5';
 									}
-									if (strcmp(strtolower($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']),$value_ext))	{
+									if (strcmp(strtolower($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']),$value_ext)) {
 										$this->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'GFX\'][\'im_version_5\']', $value_ext);
 									}
 	// 								if (strcmp(strtolower($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']),$value))	$this->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS['GFX']['im_version_5']', $value);
-								} else $this->messages[]= $errorMessages[] = "Path '".$value."' contains spaces or is longer than 100 chars (...not saved)";
+								} else {
+									$this->errorMessages[] = '
+										Path \'' . $value . '\' contains spaces
+										or is longer than 100 chars (...not
+										saved)
+									';
+								}
 							break;
 							case 'im_path_lzw':
 								list($value) = explode('|',$value);
-								if (!preg_match('/[[:space:]]/',$value) && strlen($value)<100)	{
+								if (!preg_match('/[[:space:]]/',$value) && strlen($value)<100) {
 									if (strcmp($GLOBALS['TYPO3_CONF_VARS']['GFX'][$key], $value)) {
 										$this->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'GFX\'][\'' . $key . '\']', $value);
 									}
-								} else $this->messages[]= $errorMessages[] = "Path '".$value."' contains spaces or is longer than 100 chars (...not saved)";
+								} else {
+									$this->errorMessages[] = '
+										Path \'' . $value . '\' contains spaces
+										or is longer than 100 chars (...not
+										saved)
+									';
+								}
 							break;
 							case 'TTFdpi':
 								if (strcmp($GLOBALS['TYPO3_CONF_VARS']['GFX']['TTFdpi'],$value))	$this->setValueInLocalconfFile($lines, '$TYPO3_CONF_VARS[\'GFX\'][\'TTFdpi\']', $value);
@@ -2282,12 +3874,6 @@
 
 					}
 
-					if (count($errorMessages))	{
-						echo '<h3>ERRORS</h3>';
-						echo t3lib_div::view_array($errorMessages);
-						echo 'Click the browsers "Back" button to reenter the values.';
-						exit;
-					}
 					$this->writeToLocalconf_control($lines);
 				}
 			break;
@@ -2298,23 +3884,80 @@
 	/**
 	 * Writes or returns lines from localconf.php
 	 *
-	 * @param	array		Array of lines to write back to localconf.php. Possibly
-	 * @param	boolean		If TRUE then print what has been done.
-	 * @return	mixed		If $lines is not an array it will return an array with the lines from localconf.php. Otherwise it will return a status string, either "continue" (updated) or "nochange" (not updated)
+	 * @param array $lines Array of lines to write back to localconf.php. Possibly
+	 * @param boolean $showOutput If TRUE then print what has been done.
+	 * @return mixed If $lines is not an array it will return an array with the lines from localconf.php. Otherwise it will return a status string, either "continue" (updated) or "nochange" (not updated)
 	 * @see parent::writeToLocalconf_control()
 	 */
-	function writeToLocalconf_control($lines='', $showOutput=TRUE)	{
+	function writeToLocalconf_control($lines='', $showOutput=TRUE) {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'WriteToLocalConfControl.html');
+
 		$returnVal = parent::writeToLocalconf_control($lines);
 
-		if ($showOutput)	{
-			switch($returnVal)	{
+		if ($showOutput) {
+			switch($returnVal) {
 				case 'continue':
-					$content = '<br /><br />'.implode($this->messages,'<hr />').'<br /><br /><a href="'.$this->action.'">Click to continue...</a>';
+						// Get the template part from the file
+					$template = $this->contentObject->getSubpart($templateFile, '###CONTINUE###');
+						// Get the subpart for messages
+					$messagesSubPart = $this->contentObject->getSubpart($template, '###MESSAGES###');
+
+					$messages = array();
+
+					foreach ($this->messages as $message) {
+							// Define the markers content
+						$messagesMarkers['message'] = $message;
+							// Fill the markers in the subpart
+						$messages[] = $this->contentObject->substituteMarkerArray(
+							$messagesSubPart,
+							$messagesMarkers,
+							'###|###',
+							1,
+							1
+						);
+					}
+						// Substitute the subpart for messages
+					$content = $this->contentObject->substituteSubpart(
+						$template,
+						'###MESSAGES###',
+						implode(chr(10), $messages)
+					);
+						// Define the markers content
+					$markers = array(
+						'header' => 'Writing to \'localconf.php\'',
+						'action' => $this->action,
+						'label' => 'Click to continue...'
+					);
+						// Fill the markers
+					$content = $this->contentObject->substituteMarkerArray(
+						$content,
+						$markers,
+						'###|###',
+						1,
+						1
+					);
 					$this->outputExitBasedOnStep($content);
 				break;
 				case 'nochange':
-					$content = '<strong>Writing to \'localconf.php\':</strong><br /><br />No values were changed, so nothing is updated!<br /><br /><a href="'.$this->action.'">Click to continue...</a>';
-					$this->outputExitBasedOnStep('<br />'.$content);
+						// Get the template part from the file
+					$template = $this->contentObject->getSubpart($templateFile, '###NOCHANGE###');
+						// Define the markers content
+					$markers = array(
+						'header' => 'Writing to \'localconf.php\'',
+						'message' => 'No values were changed, so nothing is updated!',
+						'action' => $this->action,
+						'label' => 'Click to continue...'
+					);
+						// Fill the markers
+					$content = $this->contentObject->substituteMarkerArray(
+						$template,
+						$markers,
+						'###|###',
+						1,
+						1
+					);
+					$this->outputExitBasedOnStep($content);
 				break;
 			}
 		}
@@ -2322,12 +3965,13 @@
 	}
 
 	/**
-	 * [Describe function...]
+	 * If in 1-2-3 mode, send a redirect header response with the action and exit
+	 * otherwise send output to output() function
 	 *
-	 * @param	[type]		$content: ...
-	 * @return	[type]		...
+	 * @param string $content The HTML to output
+	 * @return void
 	 */
-	function outputExitBasedOnStep($content)	{
+	function outputExitBasedOnStep($content) {
 		if ($this->step) {
 			t3lib_utility_Http::redirect($this->action);
 		} else {
@@ -2339,25 +3983,26 @@
 	/**
 	 * This appends something to value in the input array based on $type. Private.
 	 *
-	 * @param	[type]		$arr: ...
-	 * @param	[type]		$type: ...
-	 * @return	[type]		...
+	 * @param array $arr
+	 * @param integer $type
+	 * @return array
 	 */
-	function setLabelValueArray($arr,$type)	{
-		reset($arr);
-		while(list($k,$v)=each($arr))	{
-			if($this->config_array['im_versions'][$v]['gm'])	{
+	function setLabelValueArray($arr,$type) {
+		foreach ($arr as $k => $v) {
+			if($this->config_array['im_versions'][$v]['gm']) {
 				$program = 'gm';
 			} else	{
 				$program = 'convert';
 			}
 
-			switch($type)	{
-				case 0:	// value, im
+			switch($type) {
+					// value, im
+				case 0:
 					$arr[$k].='|'.$this->config_array['im_versions'][$v][$program];
 				break;
-				case 1:	// labels, im
-					if($this->config_array['im_versions'][$v][$program])	{
+					// labels, im
+				case 1:
+					if($this->config_array['im_versions'][$v][$program]) {
 						$arr[$k].= ' ('.$this->config_array['im_versions'][$v][$program];
 						$arr[$k].= ($this->config_array['im_versions'][$v]['gif_capability'] ? ', '.$this->config_array['im_versions'][$v]['gif_capability'] : '');
 						$arr[$k].= ')';
@@ -2365,7 +4010,8 @@
 						$arr[$k].= '';
 					}
 				break;
-				case 2: // labels, gd
+					// labels, gd
+				case 2:
 					$arr[$k].=' ('.($v==1?'PNG':'GIF').')';
 				break;
 			}
@@ -2374,38 +4020,13 @@
 	}
 
 	/**
-	 * Returns a form-element for the localconf.php update form
-	 *
-	 * @param	[type]		$labels: ...
-	 * @param	[type]		$values: ...
-	 * @param	[type]		$fieldName: ...
-	 * @param	[type]		$default: ...
-	 * @param	[type]		$msg: ...
-	 * @return	[type]		...
-	 */
-	function getFormElement($labels,$values,$fieldName,$default,$msg='')	{
-		$out.='<strong>'.htmlspecialchars(current($labels)).'</strong><br />current value is '.htmlspecialchars($default).($msg?'<br />'.$msg:'');
-		if (count($labels)>1)		{
-			reset($labels);
-			while(list($k,$v)=each($labels))	{
-				list($cleanV) =explode('|',$values[$k]);
-				$options.='<option value="'.htmlspecialchars($values[$k]).'"'.(!strcmp($default,$cleanV)?' selected="selected"':'').'>'.htmlspecialchars($v).'</option>';
-			}
-			$out.='<br /><select name="'.$fieldName.'">'.$options.'</select>';
-		} else {
-			$out.='<input type="hidden" name="'.$fieldName.'" value="'.htmlspecialchars(current($values)).'">';
-		}
-		return $out.'<br />';
-	}
-
-	/**
 	 * Returns the list of available databases (with access-check based on username/password)
 	 *
-	 * @return	[type]		...
+	 * @return array List of available databases
 	 */
-	function getDatabaseList()	{
-		$dbArr=array();
-		if ($result = $GLOBALS['TYPO3_DB']->sql_pconnect(TYPO3_db_host, TYPO3_db_username, TYPO3_db_password))	{
+	function getDatabaseList() {
+		$dbArr = array();
+		if ($result = $GLOBALS['TYPO3_DB']->sql_pconnect(TYPO3_db_host, TYPO3_db_username, TYPO3_db_password)) {
 			$dbArr = $GLOBALS['TYPO3_DB']->admin_get_dbs();
 		}
 		return $dbArr;
@@ -2425,9 +4046,9 @@
 	 * 	- im_path (default to 4.2.9, preferable with LZW)		im_ver5-flag is set based on im_path being 4.2.9 or 5+
 	 * 	- im_path_lzw (default to LZW version, pref. 4.2.9)
 	 *
-	 * @return	[type]		...
+	 * @return array Suggested setup
 	 */
-	function setupGeneralCalculate()	{
+	function setupGeneralCalculate() {
 		$formArray['disable_exec_function']=array(0);
 		$formArray['im_path']=array('');
 		$formArray['im_path_lzw']=array('');
@@ -2435,10 +4056,10 @@
 		$formArray['im_version_5']=array('');
 		$formArray['im']=array(1);
 		$formArray['gdlib']=array(1);
-		if ($this->config_array['gd'] && ($this->config_array['gd_gif'] || $this->config_array['gd_png']))	{
-			if ($this->config_array['gd_gif'] && !$this->config_array['gd_png'])	{
+		if ($this->config_array['gd'] && ($this->config_array['gd_gif'] || $this->config_array['gd_png'])) {
+			if ($this->config_array['gd_gif'] && !$this->config_array['gd_png']) {
 				$formArray['gdlib_png']=array(0);
-			} elseif (!$this->config_array['gd_gif'] && $this->config_array['gd_png'])	{
+			} elseif (!$this->config_array['gd_gif'] && $this->config_array['gd_png']) {
 				$formArray['gdlib_png']=array(1);
 			} else {
 				$formArray['gdlib_png']=array(0,1);
@@ -2446,23 +4067,21 @@
 		} else {
 			$formArray['gdlib']=array(0);
 		}
-		if ($this->config_array['safemode'])	{
+		if ($this->config_array['safemode']) {
 			$formArray['disable_exec_function']=array(1);
 		}
-		if ($this->config_array['im'])	{
-			$formArray['im']=array(1);
-			$LZW_found=0;
-			$found=0;
-			reset($this->config_array['im_versions']);
-			$totalArr=array();
-			while(list($path,$dat)=each($this->config_array['im_versions']))	{
-				if (count($dat)>=3)	{
-					if (doubleval($dat['convert'])<5)	{
+		if ($this->config_array['im']) {
+			$formArray['im'] = array(1);
+			$found = $LZW_found = 0;
+			$totalArr = array();
+			foreach ($this->config_array['im_versions'] as $path => $dat) {
+				if (count($dat)>=3) {
+					if (doubleval($dat['convert'])<5) {
 						$formArray['im_version_5']=array(0);
-						if ($dat['gif_capability']=='LZW')	{
+						if ($dat['gif_capability']=='LZW') {
 							$formArray['im_path']=array($path);
 							$found=2;
-						} elseif ($found<2)	{
+						} elseif ($found<2) {
 							$formArray['im_path']=array($path);
 							$found=1;
 						}
@@ -2471,7 +4090,7 @@
 						if ($dat['gif_capability'] == 'LZW') {
 							$formArray['im_path'] = array($path);
 							$found = 2;
-						} elseif ($found < 2)	{
+						} elseif ($found < 2) {
 							$formArray['im_path'] = array($path);
 							$found = 1;
 						}
@@ -2480,22 +4099,22 @@
 						$formArray['im_path']=array($path);
 						$found=1;
 					}
-				} elseif ($dat['gm'])	{
+				} elseif ($dat['gm']) {
 					$formArray['im_version_5']=array('gm');
-					if ($dat['gif_capability']=='LZW')	{
+					if ($dat['gif_capability']=='LZW') {
 						$formArray['im_path']=array($path);
 						$found=2;
-					} elseif ($found<2)	{
+					} elseif ($found<2) {
 						$formArray['im_path']=array($path);
 						$found=1;
 					}
 				}
-				if ($dat['gif_capability']=='LZW')	{
-					if (doubleval($dat['convert'])<5 || !$LZW_found)	{
+				if ($dat['gif_capability']=='LZW') {
+					if (doubleval($dat['convert'])<5 || !$LZW_found) {
 						$formArray['im_path_lzw']=array($path);
 						$LZW_found=1;
 					}
-				} elseif ($dat['gif_capability']=="RLE" && !$LZW_found)	{
+				} elseif ($dat['gif_capability']=="RLE" && !$LZW_found) {
 					$formArray['im_path_lzw']=array($path);
 				}
 				$totalArr[]=$path;
@@ -2512,9 +4131,9 @@
 	/**
 	 * Returns the part of phpinfo() output that tells about GD library (HTML-code)
 	 *
-	 * @return	[type]		...
+	 * @return string HTML GD Library part
 	 */
-	function getGDPartOfPhpinfo()	{
+	function getGDPartOfPhpinfo() {
 		ob_start();
 		phpinfo();
 		$contents = ob_get_contents();
@@ -2528,36 +4147,40 @@
 	}
 
 	/**
-	 * Returns true if TTF lib is install according to phpinfo(). If $phpinfo supply as parameter that string is searched instead.
+	 * Returns true if TTF lib is install according to phpinfo().
+	 * If $phpinfo supply as parameter that string is searched instead.
 	 *
-	 * @param	[type]		$phpinfo: ...
-	 * @return	[type]		...
+	 * @param string $phpinfo PHPinfo HTML
+	 * @return boolean TRUE if TrueType support
 	 */
-	function isTTF($phpinfo='')	{
+	function isTTF($phpinfo='') {
 /*		$phpinfo = $phpinfo?$phpinfo:$this->getGDPartOfPhpinfo();
 		if (stristr($phpinfo, $this->getTTF_string))    return 1;
 		if (stristr($phpinfo, $this->getTTF_string_alt))        return 1;
 		*/
 
-		if (!function_exists('imagettftext'))	return 0;	// Return right away if imageTTFtext does not exist.
+		// Return right away if imageTTFtext does not exist.
+		if (!function_exists('imagettftext')) {
+			return 0;
+		}
 
 			// try, print truetype font:
-		$im = @imagecreate (300, 50);
-		$background_color = imagecolorallocate ($im, 255, 255, 55);
-		$text_color = imagecolorallocate ($im, 233, 14, 91);
+		$im = @imagecreate(300, 50);
+		$background_color = imagecolorallocate($im, 255, 255, 55);
+		$text_color = imagecolorallocate($im, 233, 14, 91);
 
 		$test = @imagettftext($im, t3lib_div::freetypeDpiComp(20), 0, 10, 20, $text_color, PATH_t3lib."/fonts/vera.ttf", 'Testing Truetype support');
-		if (t3lib_div::_GP('testingTrueTypeSupport'))	{
-			if ($this->isGIF())	{
-				header ('Content-type: image/gif');
-				imagegif ($im);
+		if (t3lib_div::_GP('testingTrueTypeSupport')) {
+			if ($this->isGIF()) {
+				header('Content-type: image/gif');
+				imagegif($im);
 			} else {
-				header ('Content-type: image/png');
-				imagepng ($im);
+				header('Content-type: image/png');
+				imagepng($im);
 			}
 			exit;
 		}
-		return is_array($test)?1:0;
+		return (is_array($test) ? 1 : 0);
 	}
 
 
@@ -2580,83 +4203,106 @@
 	 */
 
 	/**
-	 * @return	[type]		...
+	 * Check if GD module is available by checking the function imagecreate
+	 *
+	 * @return boolean TRUE if GD is available
 	 */
-	function isGD()	{
-		if (function_exists('imagecreate'))	{
-			if (@imagecreate (50, 100))	return 1;
+	function isGD() {
+		if (function_exists('imagecreate')) {
+			if (@imagecreate(50, 100)) {
+				return 1;
+			}
 		}
+		return 0;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if GIF functions are available
 	 *
-	 * @return	[type]		...
+	 * @return boolean TRUE if GIF functions are available
 	 */
-	function isGIF()	{
-		if (function_exists('imagecreatefromgif') && function_exists('imagegif') && ($this->ImageTypes() & IMG_GIF))	{	// If GIF-functions exists, also do a real test of them:
+	function isGIF() {
+			// If GIF-functions exists, also do a real test of them:
+		if (function_exists('imagecreatefromgif') && function_exists('imagegif') && ($this->ImageTypes() & IMG_GIF)) {
 			$im = @imagecreatefromgif(t3lib_extMgm::extPath('install').'imgs/jesus.gif');
-			return $im?1:0;
+			return ($im ? 1 : 0);
 		}
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if JPG functions are available
 	 *
-	 * @return	[type]		...
+	 * @return boolean TRUE if JPEG functions are available
 	 */
-	function isJPG()	{
-		if (function_exists('imagecreatefromjpeg') && function_exists('imagejpeg') && ($this->ImageTypes() & IMG_JPG))	{
+	function isJPG() {
+		if (function_exists('imagecreatefromjpeg') && function_exists('imagejpeg') && ($this->ImageTypes() & IMG_JPG)) {
 			return 1;
 		}
 	}
 
 	/**
-	 * [Describe function...]
+	 * Check if PNG functions are available
 	 *
-	 * @return	[type]		...
+	 * @return boolean TRUE if PNG functions are available
 	 */
-	function isPNG()	{
-		if (function_exists('imagecreatefrompng') && function_exists('imagepng') && ($this->ImageTypes() & IMG_PNG))	{
+	function isPNG() {
+		if (function_exists('imagecreatefrompng') && function_exists('imagepng') && ($this->ImageTypes() & IMG_PNG)) {
 			$im = imagecreatefrompng(t3lib_extMgm::extPath('install').'imgs/jesus.png');
-			return $im?1:0;
+			return ($im ? 1 : 0);
 		}
 	}
 
 	/**
-	 * [Describe function...]
+	 * Return the image types supported by this PHP build
 	 *
-	 * @return	[type]		...
+	 * @return integer A bit-field corresponding to the image formats supported by the version of GD linked into PHP. The following bits are returned, IMG_GIF | IMG_JPG | IMG_PNG | IMG_WBMP | IMG_XPM.
 	 */
-	function ImageTypes()	{
+	function ImageTypes() {
 		return imagetypes();
 	}
 
 	/**
 	 * Returns general information about GDlib
 	 *
-	 * @return	[type]		...
+	 * @return string HTML with GD lib information
 	 */
-	function getGDSoftwareInfo()	{
-		return trim('
-		You can get GDLib in the PNG version from ' . $this->linkIt('http://www.libgd.org/') . 
-		'. <br />FreeType is for download at ' . $this->linkIt('http://www.freetype.org/') . 
-		'. <br />Generally, TYPO3 packages are listed at ' . $this->linkIt('http://typo3.org/download/packages/') . '.'
-		);
+	function getGDSoftwareInfo() {
+		return '
+			<p>
+				You can get GDLib in the PNG version from
+				<a href="http://www.libgd.org/">http://www.libgd.org/</a>
+				<br />
+				FreeType is for download at
+				<a href="http://www.freetype.org/">http://www.freetype.org/</a>
+				<br />
+				Generally, TYPO3 packages are listed at
+				<a href="http://typo3.org/download/packages/">http://typo3.org/download/packages/</a>
+			</p>
+		';
 	}
 
 	/**
 	 * Returns general information about configuration of TYPO3.
 	 *
-	 * @return	[type]		...
+	 * @return string HTML with the general information
 	 */
-	function generallyAboutConfiguration()	{
-		$out='
-		Local configuration is done by overriding default values in the included file, typo3conf/localconf.php. In this file you enter the database information along with values in the global array TYPO3_CONF_VARS.
-		The options in the TYPO3_CONF_VARS array and how to use it for your own purposes is discussed in the base configuration file, t3lib/config_default.php. This file sets up the default values and subsequently includes the localconf.php file in which you can then override values.
-		See this page for '.$this->linkIt('http://typo3.org/1275.0.html','more information about system requirements.').'
-		';
-		return trim($out);
+	function generallyAboutConfiguration() {
+		return '
+		<p>
+			Local configuration is done by overriding default values in the
+			included file, typo3conf/localconf.php. In this file you enter the
+			database information along with values in the global array
+			TYPO3_CONF_VARS.
+			<br />
+			The options in the TYPO3_CONF_VARS array and how to use it for your
+			own purposes is discussed in the base configuration file,
+			t3lib/config_default.php. This file sets up the default values and
+			subsequently includes the localconf.php file in which you can then
+			override values.
+			<br />
+			See this page for <a href="http://typo3.org/1275.0.html">more
+			information about system requirements.</a>
+		</p>';
 	}
 
 
@@ -2708,44 +4354,110 @@
 	 *
 	 * From TypoScript: (GD only, GD+IM, IM)
 	 *
-	 * @return	[type]		...
+	 * @return void
 	 */
-	function checkTheImageProcessing()	{
-		$this->message('Image Processing','What is it?',"
-		TYPO3 is known for its ability to process images on the server.
-		In the backend interface (TBE) thumbnails are automatically generated (by ImageMagick in thumbs.php) as well as icons, menu items and pane tabs (by GDLib).
-		In the TypoScript enabled frontend all kinds of graphical elements are processed. Typically images are scaled down to fit the pages (by ImageMagick) and menu items, graphical headers and such are generated automatically (by GDLib + ImageMagick).
-		In addition TYPO3 is able to handle many file formats (thanks to ImageMagick), for example TIF, BMP, PCX, TGA, AI and PDF in addition to the standard web formats; JPG, GIF, PNG.
+	function checkTheImageProcessing() {
+		$this->message('Image Processing', 'What is it?', '
+			<p>
+				TYPO3 is known for its ability to process images on the server.
+				<br />
+				In the backend interface (TBE) thumbnails are automatically
+				generated (by ImageMagick in thumbs.php) as well as icons, menu
+				items and pane tabs (by GDLib).
+				<br />
+				In the TypoScript enabled frontend all kinds of graphical
+				elements are processed. Typically images are scaled down to fit
+				the pages (by ImageMagick) and menu items, graphical headers and
+				such are generated automatically (by GDLib + ImageMagick).
+				<br />
+				In addition TYPO3 is able to handle many file formats (thanks to
+				ImageMagick), for example TIF, BMP, PCX, TGA, AI and PDF in
+				addition to the standard web formats; JPG, GIF, PNG.
+			</p>
+			<p>
+				In order to do this, TYPO3 uses two sets of tools:
+			</p>
+			<p>
+				<strong>ImageMagick:</strong>
+				<br />
+				For conversion of non-web formats to webformats, combining
+				images with alpha-masks, performing image-effects like blurring
+				and sharpening.
+				<br />
+				ImageMagick is a collection of external programs on the server
+				called by the exec() function in PHP. TYPO3 uses three of these,
+				namely \'convert\' (converting fileformats, scaling, effects),
+				\'combine\'/\'composite\' (combining images with masks) and
+				\'identify\' (returns image information).
+				<br />
+				Because ImageMagick are external programs, two requirements must
+				be met: 1) The programs must be installed on the server and
+				working and 2) if safe_mode is enabled, the programs must be
+				located in the folder defined by the php.ini setting,
+				<em>safe_mode_exec_dir</em> (else they are not executed).
+				<br />
+				ImageMagick is available for both Windows and Unix. The current
+				version is 5+, but TYPO3 enthusiasts prefer an old version 4.2.9
+				because that version has three main advantages: It\'s faster in
+				some operations, the blur-function works, the sharpen-function
+				works. Anyway you do it, you must tell TYPO3 by configuration
+				whether you\'re using version 5+ or 4.2.9. (flag:
+				[GFX][im_version_5])
+				<br />
+				ImageMagick homepage is at <a href="http://www.imagemagick.org/">http://www.imagemagick.org/</a>
+			</p>
+			<p>
+				<strong>GDLib:</strong>
+				<br />
+				For drawing boxes and rendering text on images with truetype
+				fonts. Also used for icons, menuitems and generally the
+				TypoScript GIFBUILDER object is based on GDlib, but extensively
+				utilizing ImageMagick to process intermediate results.
+				<br />
+				GDLib is accessed through internal functions in PHP, so in this
+				case, you have no safe_mode problems, but you\'ll need a version
+				of PHP with GDLib compiled in. Also in order to use TrueType
+				fonts with GDLib you\'ll need FreeType compiled in as well.
+				<br />
+			</p>
+			' . $this->getGDSoftwareInfo() . '
+			<p>
+				You can disable all image processing options in TYPO3
+				([GFX][image_processing]=0), but that would seriously disable
+				TYPO3.
+			</p>
+		');
 
-		In order to do this, TYPO3 uses two sets of tools:
-
-		<strong>ImageMagick:</strong>
-		For conversion of non-web formats to webformats, combining images with alpha-masks, performing image-effects like blurring and sharpening.
-		ImageMagick is a collection of external programs on the server called by the exec() function in PHP. TYPO3 uses three of these, namely 'convert' (converting fileformats, scaling, effects), 'combine'/'composite' (combining images with masks) and 'identify' (returns image information).
-		Because ImageMagick are external programs, two requirements must be met: 1) The programs must be installed on the server and working and 2) if safe_mode is enabled, the programs must be located in the folder defined by the php.ini setting, <em>safe_mode_exec_dir</em> (else they are not executed).
-		ImageMagick is available for both Windows and Unix. The current version is 5+, but TYPO3 enthusiasts prefer an old version 4.2.9 because that version has three main advantages: It's faster in some operations, the blur-function works, the sharpen-function works. Anyway you do it, you must tell TYPO3 by configuration whether you're using version 5+ or 4.2.9. (flag: [GFX][im_version_5])
-		ImageMagick homepage is at ".$this->linkIt('http://www.imagemagick.org/')."
-
-		<strong>GDLib:</strong>
-		For drawing boxes and rendering text on images with truetype fonts. Also used for icons, menuitems and generally the TypoScript GIFBUILDER object is based on GDlib, but extensively utilizing ImageMagick to process intermediate results.
-		GDLib is accessed through internal functions in PHP, so in this case, you have no safe_mode problems, but you'll need a version of PHP with GDLib compiled in. Also in order to use TrueType fonts with GDLib you'll need FreeType compiled in as well.
-		".$this->getGDSoftwareInfo().'
-
-		You can disable all image processing options in TYPO3 ([GFX][image_processing]=0), but that would seriously disable TYPO3.
+		$this->message('Image Processing', 'Verifying the image processing capabilities of your server', '
+			<p>
+				This page performs image processing and displays the result.
+				It\'s a thorough check that everything you\'ve configured is
+				working correctly.
+				<br />
+				It\'s quite simple to verify your installation; Just look down
+				the page, the images in pairs should look like each other. If
+				some images are not alike, something is wrong. You may also
+				notice warnings and errors if this tool found signs of any
+				problems.
+			</p>
+			<p>
+				The image to the right is the reference image (how it should be)
+				and to the left the image made by your server.
+				<br />
+				The reference images are made with the classic ImageMagick
+				install based on the 4.2.9 RPM and 5.2.3 RPM. If the version 5
+				flag is set, the reference images are made by the 5.2.3 RPM.
+			</p>
+			<p>
+				This test will work only if your ImageMagick/GDLib configuration
+				allows it to. The typo3temp/ folder must be writable for all the
+				temporary image files. They are all prefixed \'install_\' so
+				they are easy to recognize and delete afterwards.
+			</p>
 		');
 
-		$this->message('Image Processing','Verifying the image processing capabilities of your server',"
-		This page performs image processing and displays the result. It's a thorough check that everything you've configured is working correctly.
-		It's quite simple to verify your installation; Just look down the page, the images in pairs should look like each other. If some images are not alike, something is wrong. You may also notice warnings and errors if this tool found signs of any problems.
-
-		The image to the right is the reference image (how it should be) and to the left the image made by your server.
-		The reference images are made with the classic ImageMagick install based on the 4.2.9 RPM and 5.2.3 RPM. If the version 5 flag is set, the reference images are made by the 5.2.3 RPM.
-
-		This test will work only if your ImageMagick/GDLib configuration allows it to. The typo3temp/ folder must be writable for all the temporary image files. They are all prefixed 'install_' so they are easy to recognize and delete afterwards.
-		");
-
 		$im_path = $GLOBALS['TYPO3_CONF_VARS']['GFX']['im_path'];
-		if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']=='gm')	{
+		if ($GLOBALS['TYPO3_CONF_VARS']['GFX']['im_version_5']=='gm') {
 			$im_path_version = $this->config_array['im_versions'][$im_path]['gm'];
 		} else {
 			$im_path_version = $this->config_array['im_versions'][$im_path]['convert'];
